#!/usr/bin/perl

$have_params=0;
$have_labels=0;
while(<>) {
    chomp;
    if(m/^p edge ([0-9]+) ([0-9]+)/) {
	if($have_params) {
	    die "duplicate DIMACS format line";
	}
	$have_params=1;
	$nv=$1;
	$ne=$2;
	$ec=0;
    } elsif(m/^n ([0-9]+) (.+)/) {
	if(!$have_params) {
	    die "DIMACS format line missing";
	}
	$have_labels=1;
	$v=$1-1;
	$lab=$2;
	if($v>=$nv) {
	    die "invalid vertex label specification";
	}
	if(defined $vlab{$rp[$v]}) {
	    die "duplicate vertex label specification";
	}
	$vlab[$v]=$lab;
        if(defined $labclass{$lab}) {
	    $labclass{$lab}=$labclass{$lab}." $v";
	} else {
	    $labclass{$lab}="$v";
	}
    } elsif(m/^e ([0-9]+) ([0-9]+)/) {
	if(!$have_params) {
	    die "DIMACS format line missing";
	}
	$i=$1-1;
	$j=$2-1;
	if($i > $j) {
	    $t = $i;
	    $i = $j;
	    $j = $t;
	}
	if($i >= $nv || $j >= $nv || $i==$j) {
	    die "invalid edge specification";
	}
	if(defined $edge{"$i $j"}) {
	    die "repeated edge found";
	}
	$edge{"$i $j"}=1;
	$adj{$i}=$adj{$i}." $j";
	$adj{$j}=$adj{$j}." $i";
	$ec++;
    } elsif(m/^c /) {
	# Comment line. Ignore.
    } elsif(m/^ *$/) {
	# Blank line. Ignore.
    } else {
	die "parse error";
    }
}
if($ec!=$ne) {
    die "invalid number of edges";
}
if($have_labels) {
    for($i=0;$i<$nv;$i++) {
	if(!defined($vlab[$i])) {
	    die "missing vertex label(s)";
	}
    }
}
print "n=$nv g\n";
for($i=0;$i<$nv;$i++) {
    print "$adj{$i};\n"
}
if($have_labels) {
    @id=sort keys %labclass;
    for($i=0;$i<=$#id;$i++) {
	$labclass{$id[$i]}=join(',',(sort {$a <=> $b} (split / /,$labclass{$id[$i]})));
    }
    print "f=[";
    for($i=0;$i<=$#id;$i++) {
	print $labclass{$id[$i]};
	if($i<$#id) {
	    print "|";
	}
    }
    print "]\n";
}
print "x\n";
